#!/bin/sh
# generate udev rules for handling anaconda-specific root devices
# (just the disk-based ones - the network ones are done by netroot)

. /lib/anaconda-lib.sh
echo "in file pre-trigger/50-repo-genrules.sh root is $root "
case "$root" in
  anaconda-disk:*)
    /usr/bin/echo "in 50-repo-genrules.sh 1111111111111" >> /tmp/duanqi.log
    # anaconda-disk:<device>[:<path>]
    /usr/bin/echo "root is:$root" >> /tmp/duanqi.log
    ARCH=`uname -m`
    echo $ARCH |grep mips
    if [ $? -eq 0 ];then
	/usr/bin/echo "mips arch!" >> /tmp/duanqi.log
    	splitsep ":" "$root" f diskdev diskpath
    	/usr/bin/echo "diskdev is:$diskdev , diskpath is $diskpath , f is $f"  >> /tmp/duanqi.log
    	/bin/cat /proc/cmdline | /bin/grep "inst.stage2"   # for dvd install
    	res=$?
    	if [ $res -eq 0 ];then  
        	/usr/bin/echo "inst.stage2 in cmdline" >> /tmp/duanqi.log
    		diskdev="/dev/sr*"
    	else
        	/usr/bin/echo "inst.stage2 NOT in cmdline" >> /tmp/duanqi.log
    		diskdev=$(disk_to_dev_path $diskdev)
    	fi
    	/usr/bin/echo "diskdev is:$diskdev" >> /tmp/duanqi.log
    	if [ $res -eq 0 ];then 
		/bin/mkdir -p /tmp/iso	
    		for i in `ls /dev/sr*`;do
			/bin/mount $i /tmp/iso -o loop
			res1=$?
			#if [ $res1 -eq 0 ] && [ -e /tmp/iso/.discinfo ];then
			if [ $res1 -eq 0 ] && [ -e /tmp/iso/productinfo ];then
				/bin/umount /tmp/iso	
				DEV=$i
				break
			else
				/bin/umount /tmp/iso	
				continue	
			fi
    		done 
		if [ -z "$DEV" ];then
		    /usr/bin/echo "cannot find cdrom,try to find usb device ..." >> /tmp/duanqi.log
		    USBDEV=$(blkid |sed -e s/\"//g|grep $diskdev|sed -e s/\:.*//)
    		    for i in $USBDEV ;do
			/usr/bin/echo "check $i ..." >> /tmp/duanqi.log
			/bin/mount $i /tmp/iso -o loop
			res1=$?
			#if [ $res1 -eq 0 ] && [ -e /tmp/iso/.discinfo ];then
			if [ $res1 -eq 0 ] && [ -e /tmp/iso/productinfo ];then
				/bin/umount /tmp/iso	
				diskdev=$i
				DEV=$i
				/bin/cp /tmp/iso/ks.cfg /tmp/
				touch /tmp/ks.cfg.done
				/usr/bin/echo "check USB-install device ($DEV) is OK" >> /tmp/duanqi.log
				break
			else
				/bin/umount /tmp/iso	
				continue	
			fi
    		    done
		fi 
		rm -rf /tmp/iso
    		/usr/bin/echo "DEV is:$DEV" >> /tmp/duanqi.log
    		when_diskdev_appears $DEV \
        		anaconda-diskroot $DEV $diskpath
    	else
    		when_diskdev_appears $diskdev \
        		anaconda-diskroot \$env{DEVNAME} $diskpath
    	fi
    else
	/usr/bin/echo "NOT mips arch!" >> /tmp/duanqi.log
	splitsep ":" "$root" f diskdev diskpath
    	diskdev=$(disk_to_dev_path $diskdev)
    	when_diskdev_appears $diskdev \
        anaconda-diskroot \$env{DEVNAME} $diskpath
    fi
  ;;
  anaconda-auto-cd)
    # special catch-all rule for CDROMs
    echo 'ENV{ID_CDROM}=="1",' \
           'RUN+="/sbin/initqueue --settled --onetime' \
             '/sbin/anaconda-diskroot $env{DEVNAME}"' >> $rulesfile
    # HACK: anaconda demands that CDROMs be mounted at /mnt/install/source
    ln -s repo /run/install/source
  ;;
esac
